#include <bits/stdc++.h>

using namespace std;

int main()
{
            int n;
            long k;
            

            scanf("%d%ld",&n,&k);
            long brojbrojeva[k+1];
            long a[n + 1][ n + 1];
            int brojpravougaonika = 0;

            for (long i = 0; i <= k; i++)
            {
                brojbrojeva[i] = 0;
            }

            for (int i = 0; i < n; i++)
            {
                for (int j = 0; j < n; j++)
                {
                    scanf("%ld",&a[i][j]);
                    brojbrojeva[a[i][j]]++;
                }
            }

            for (int i = 0; i < n; i++)
            {
                for (int j = 0; j < n; j++)
                {
                    int sirina = 0;
                    int visina = 0;

                    if (i == 0 && j == 0)
                    {
                        while (a[i][ j + sirina] == a[i][ j])
                        { sirina++; }

                        while (a[i + visina][j] == a[i][j])
                        {
                            visina++;
                        }

                        bool pravougaonik = true;
                        for (int p = 1; p < visina; p++)
                        {
                            for (int q = 1; q < sirina; q++)
                            {
                                if (a[i + p][j + q] != a[i][j])
                                {
                                    pravougaonik = false;
                                }

                            }
                        }
                        if (pravougaonik && visina * sirina == brojbrojeva[a[i][j]])
                        { brojpravougaonika++; }
                    }
                    else if (i == 0)
                    {
                        if (a[i][ j - 1] != a[i][j])
                        {
                            while (a[i][j + sirina] == a[i][j])
                            { sirina++; }

                            while (a[i + visina][j] == a[i][j])
                            {
                                visina++;
                            }

                            bool pravougaonik = true;
                            for (int p = 1; p < visina; p++)
                            {
                                for (int q = 1; q < sirina; q++)
                                {
                                    if (a[i + p][j + q] != a[i][j])
                                    {
                                        pravougaonik = false;
                                    }

                                }
                            }
                            if (pravougaonik && visina * sirina == brojbrojeva[a[i][j]])
                            { brojpravougaonika++; }
                        }
                    }
                    else if (j == 0)
                    {
                        if (a[i - 1][j] == a[i][j])
                        {
                            while (a[i][j + sirina] == a[i][j])
                            { sirina++; }

                            while (a[i + visina][j] == a[i][j])
                            {
                                visina++;
                            }

                            bool pravougaonik = true;
                            for (int p = 1; p < visina; p++)
                            {
                                for (int q = 1; q < sirina; q++)
                                {
                                    if (a[i + p][j + q] != a[i][j])
                                    {
                                        pravougaonik = false;
                                    }

                                }
                            }
                            if (pravougaonik && visina * sirina == brojbrojeva[a[i][j]])
                            { brojpravougaonika++; }
                        }
                    }
                    else
                    {
                        while (a[i][j + sirina] == a[i][j])
                        { sirina++; }

                        while (a[i + visina][j] == a[i][j])
                        {
                            visina++;
                        }

                        bool pravougaonik = true;
                        for (int p = 1; p < visina; p++)
                        {
                            for (int q = 1; q < sirina; q++)
                            {
                                if (a[i + p][j + q] != a[i][j])
                                {
                                    pravougaonik = false;
                                }

                            }
                        }
                        if (pravougaonik && visina * sirina == brojbrojeva[a[i][j]])
                        { brojpravougaonika++; }
                    }
                    

                }
            }
            printf("%ld",brojpravougaonika);
    
    return 0;
}